﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Media.Media3D;
using System.Windows.Navigation;
using System.Windows.Shapes;
using _3DTools;

namespace Test_3D
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            Model3DGroup models = new Model3DGroup();

            Point3D p0 = new Point3D(-1, -1, -1);
            Point3D p1 = new Point3D(1, -1, -1);
            Point3D p2 = new Point3D(1, -1, 1);
            Point3D p3 = new Point3D(-1, -1, 1);
            Point3D p4 = new Point3D(-1, 1, -1);
            Point3D p5 = new Point3D(1, 1, -1);
            Point3D p6 = new Point3D(1, 1, 1);
            Point3D p7 = new Point3D(-1, 1, 1);

            models.Children.Add(CreateRectangle(p3, p2, p6, p7, Brushes.Red));
            models.Children.Add(CreateRectangle(p2, p1, p5, p6, Brushes.Red));
            models.Children.Add(CreateRectangle(p1, p0, p4, p5, Brushes.Red));
            models.Children.Add(CreateRectangle(p0, p3, p7, p4, Brushes.Red));
            //models.Children.Add(CreateRectangle(p7, p6, p5, p4, Brushes.Red));
            models.Children.Add(CreateRectangle(p2, p3, p0, p1, Brushes.Red));

            MeshGeometry3D interactivemesh;
            CreateRectangle(p7, p6, p5, p4, Brushes.Red, out interactivemesh);

            InteractiveVisual3D interactive = new InteractiveVisual3D();
            interactive.Geometry = interactivemesh;
            interactive.Visual = (Visual)FindResource("VideoControl");
            myViewport3D.Children.Add(interactive);

            ModelVisual3D visual = new ModelVisual3D();
            visual.Content = models;
            myViewport3D.Children.Add(visual);
        }

        public GeometryModel3D CreateRectangle(
            Point3D point1, Point3D point2,
            Point3D point3, Point3D point4,
            Brush brush)
        {
            MeshGeometry3D mesh;
            return CreateRectangle(point1, point2, point3, point4, brush, out mesh);
        }

        public GeometryModel3D CreateRectangle(
            Point3D point1, Point3D point2,
            Point3D point3, Point3D point4,
            Brush brush, out MeshGeometry3D mesh)
        {
            mesh = new MeshGeometry3D();
            mesh.Positions.Add(point1);
            mesh.Positions.Add(point2);
            mesh.Positions.Add(point3);
            mesh.Positions.Add(point4);

            mesh.TriangleIndices.Add(0);
            mesh.TriangleIndices.Add(1);
            mesh.TriangleIndices.Add(2);

            mesh.TriangleIndices.Add(0);
            mesh.TriangleIndices.Add(2);
            mesh.TriangleIndices.Add(3);

            mesh.TextureCoordinates.Add(new Point(0, 1));
            mesh.TextureCoordinates.Add(new Point(1, 1));
            mesh.TextureCoordinates.Add(new Point(1, 0));
            mesh.TextureCoordinates.Add(new Point(0, 0));

            return new GeometryModel3D(mesh, 
                new DiffuseMaterial(brush));
        }

        private void Play(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Clicked Play");
        }

        private void Pause(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Clicked Pause");
        }
    }
}
